Package org.eclipse.jdt.core.dom

# Class EnumConstantDeclaration

java.lang.Object
org.eclipse.jdt.core.dom.ASTNode
org.eclipse.jdt.core.dom.BodyDeclaration
org.eclipse.jdt.core.dom.EnumConstantDeclaration

public class EnumConstantDeclaration extends BodyDeclaration
Enumeration constant declaration AST node type (added in JLS3 API).

     EnumConstantDeclaration:
         [ Javadoc ] { ExtendedModifier } Identifier
             [ ( [ Expression { , Expression } ] ) ]
             [ AnonymousClassDeclaration ]

When a Javadoc comment is present, the source range begins with the first character of the "/**" comment delimiter. When there is no Javadoc comment, the source range begins with the first character of the identifier. If there are class body declarations, the source range extends through the last character of the last character of the "}" token following the body declarations. If there are arguments but no class body declarations, the source range extends through the last character of the ")" token following the arguments. If there are no arguments and no class body declarations, the source range extends through the last character of the identifier.

Since:
  3.1
Restriction:
  This class is not intended to be instantiated by clients.

## Field Summary

Fields
Modifier and Type
Field
Description
`static final ChildPropertyDescriptor`
`ANONYMOUS_CLASS_DECLARATION_PROPERTY`
The "anonymousClassDeclaration" structural property of this node type (child type: `AnonymousClassDeclaration`).
`static final ChildListPropertyDescriptor`
`ARGUMENTS_PROPERTY`
The "arguments" structural property of this node type (element type: `Expression`).
`static final ChildPropertyDescriptor`
`JAVADOC_PROPERTY`
The "javadoc" structural property of this node type (child type: `Javadoc`).
`static final ChildListPropertyDescriptor`
`MODIFIERS2_PROPERTY`
The "modifiers" structural property of this node type (element type: `IExtendedModifier`).
`static final ChildPropertyDescriptor`
`NAME_PROPERTY`
The "name" structural property of this node type (child type: `SimpleName`).

### Fields inherited from class org.eclipse.jdt.core.dom.ASTNode

`ANNOTATION_TYPE_DECLARATION, ANNOTATION_TYPE_MEMBER_DECLARATION, ANONYMOUS_CLASS_DECLARATION, ARRAY_ACCESS, ARRAY_CREATION, ARRAY_INITIALIZER, ARRAY_TYPE, ASSERT_STATEMENT, ASSIGNMENT, BLOCK, BLOCK_COMMENT, BOOLEAN_LITERAL, BREAK_STATEMENT, CASE_DEFAULT_EXPRESSION, CAST_EXPRESSION, CATCH_CLAUSE, CHARACTER_LITERAL, CLASS_INSTANCE_CREATION, COMPILATION_UNIT, CONDITIONAL_EXPRESSION, CONSTRUCTOR_INVOCATION, CONTINUE_STATEMENT, CREATION_REFERENCE, DIMENSION, DO_STATEMENT, EitherOr_MultiPattern, EMPTY_STATEMENT, ENHANCED_FOR_STATEMENT, ENUM_CONSTANT_DECLARATION, ENUM_DECLARATION, EXPORTS_DIRECTIVE, EXPRESSION_METHOD_REFERENCE, EXPRESSION_STATEMENT, FIELD_ACCESS, FIELD_DECLARATION, FOR_STATEMENT, GUARDED_PATTERN, IF_STATEMENT, IMPORT_DECLARATION, INFIX_EXPRESSION, INITIALIZER, INSTANCEOF_EXPRESSION, INTERSECTION_TYPE, JAVADOC, JAVADOC_REGION, JAVADOC_TEXT_ELEMENT, LABELED_STATEMENT, LAMBDA_EXPRESSION, LINE_COMMENT, MALFORMED, MARKER_ANNOTATION, MEMBER_REF, MEMBER_VALUE_PAIR, METHOD_DECLARATION, METHOD_INVOCATION, METHOD_REF, METHOD_REF_PARAMETER, MODIFIER, MODULE_DECLARATION, MODULE_MODIFIER, MODULE_QUALIFIED_NAME, NAME_QUALIFIED_TYPE, NORMAL_ANNOTATION, NULL_LITERAL, NULL_PATTERN, NUMBER_LITERAL, OPENS_DIRECTIVE, ORIGINAL, PACKAGE_DECLARATION, PARAMETERIZED_TYPE, PARENTHESIZED_EXPRESSION, PATTERN_INSTANCEOF_EXPRESSION, POSTFIX_EXPRESSION, PREFIX_EXPRESSION, PRIMITIVE_TYPE, PROTECT, PROVIDES_DIRECTIVE, QUALIFIED_NAME, QUALIFIED_TYPE, RECORD_DECLARATION, RECORD_PATTERN, RECOVERED, REQUIRES_DIRECTIVE, RETURN_STATEMENT, SIMPLE_NAME, SIMPLE_TYPE, SINGLE_MEMBER_ANNOTATION, SINGLE_VARIABLE_DECLARATION, STRING_FRAGMENT, STRING_LITERAL, STRING_TEMPLATE_COMPONENT, STRING_TEMPLATE_EXPRESSION, SUPER_CONSTRUCTOR_INVOCATION, SUPER_FIELD_ACCESS, SUPER_METHOD_INVOCATION, SUPER_METHOD_REFERENCE, SWITCH_CASE, SWITCH_EXPRESSION, SWITCH_STATEMENT, SYNCHRONIZED_STATEMENT, TAG_ELEMENT, TAG_PROPERTY, TEXT_BLOCK, TEXT_ELEMENT, THIS_EXPRESSION, THROW_STATEMENT, TRY_STATEMENT, TYPE_DECLARATION, TYPE_DECLARATION_STATEMENT, TYPE_LITERAL, TYPE_METHOD_REFERENCE, TYPE_PARAMETER, TYPE_PATTERN, UNION_TYPE, UNNAMED_CLASS, USES_DIRECTIVE, VARIABLE_DECLARATION_EXPRESSION, VARIABLE_DECLARATION_FRAGMENT, VARIABLE_DECLARATION_STATEMENT, WHILE_STATEMENT, WILDCARD_TYPE, YIELD_STATEMENT`

## Method Summary

Modifier and Type
Method
Description
`List`
`arguments()`
Returns the live ordered list of argument expressions in this enumeration constant declaration.
`AnonymousClassDeclaration`
`getAnonymousClassDeclaration()`
Returns the anonymous class declaration introduced by this enum constant declaration, if it has one.
`SimpleName`
`getName()`
Returns the name of the constant declared in this enum declaration.
`static List`
`propertyDescriptors(int apiLevel)`
Returns a list of structural property descriptors for this node type.
`IMethodBinding`
`resolveConstructorBinding()`
Resolves and returns the binding for the constructor invoked by this enum constant.
`IVariableBinding`
`resolveVariable()`
Resolves and returns the field binding for this enum constant.
`void`
`setAnonymousClassDeclaration(AnonymousClassDeclaration decl)`
Sets whether this enum constant declaration declares an anonymous class (that is, has class body declarations).
`void`
`setName(SimpleName constantName)`
Sets the name of the constant declared in this enum declaration to the given name.

### Methods inherited from class org.eclipse.jdt.core.dom.BodyDeclaration

`getJavadoc, getJavadocProperty, getModifiers, getModifiersProperty, modifiers, setJavadoc, setModifiers`

### Methods inherited from class org.eclipse.jdt.core.dom.ASTNode

`accept, copySubtree, copySubtrees, delete, equals, getAST, getFlags, getLength, getLocationInParent, getNodeType, getParent, getProperty, getRoot, getStartPosition, getStructuralProperty, hashCode, nodeClassForType, properties, setFlags, setProperty, setSourceRange, setStructuralProperty, structuralPropertiesForType, subtreeBytes, subtreeMatch, toString`

### Methods inherited from class java.lang.Object

`clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

## Field Details

### JAVADOC_PROPERTY

public static final ChildPropertyDescriptor JAVADOC_PROPERTY
The "javadoc" structural property of this node type (child type: `Javadoc`).

### MODIFIERS2_PROPERTY

public static final ChildListPropertyDescriptor MODIFIERS2_PROPERTY
The "modifiers" structural property of this node type (element type: `IExtendedModifier`).

### NAME_PROPERTY

public static final ChildPropertyDescriptor NAME_PROPERTY
The "name" structural property of this node type (child type: `SimpleName`).

### ARGUMENTS_PROPERTY

public static final ChildListPropertyDescriptor ARGUMENTS_PROPERTY
The "arguments" structural property of this node type (element type: `Expression`).

### ANONYMOUS_CLASS_DECLARATION_PROPERTY

public static final ChildPropertyDescriptor ANONYMOUS_CLASS_DECLARATION_PROPERTY
The "anonymousClassDeclaration" structural property of this node type (child type: `AnonymousClassDeclaration`).

## Method Details

### propertyDescriptors

public static List propertyDescriptors(int apiLevel)
Returns a list of structural property descriptors for this node type. Clients must not modify the result.

Parameters:
  `apiLevel` - the API level; one of the `AST.JLS*` constants
Returns:
  a list of property descriptors (element type: `StructuralPropertyDescriptor`)

### getName

public SimpleName getName()
Returns the name of the constant declared in this enum declaration.

Returns:
  the constant name node

### setName

public void setName(SimpleName constantName)
Sets the name of the constant declared in this enum declaration to the given name.

Parameters:
  `constantName` - the new constant name
Throws:
  `IllegalArgumentException` - if:
  - the node belongs to a different AST
  - the node already has a parent

### arguments

public List arguments()
Returns the live ordered list of argument expressions in this enumeration constant declaration. Note that an empty list of arguments is equivalent to not explicitly specifying arguments.

Returns:
  the live list of argument expressions (element type: `Expression`)

### getAnonymousClassDeclaration

public AnonymousClassDeclaration getAnonymousClassDeclaration()
Returns the anonymous class declaration introduced by this enum constant declaration, if it has one.

Returns:
  the anonymous class declaration, or `null` if none

### setAnonymousClassDeclaration

public void setAnonymousClassDeclaration(AnonymousClassDeclaration decl)
Sets whether this enum constant declaration declares an anonymous class (that is, has class body declarations).

Parameters:
  `decl` - the anonymous class declaration, or `null` if none

### resolveConstructorBinding

public IMethodBinding resolveConstructorBinding()
Resolves and returns the binding for the constructor invoked by this enum constant.

Note that bindings are generally unavailable unless requested when the AST is being built.

Returns:
  the constructor binding, or `null` if the binding cannot be resolved

### resolveVariable

public IVariableBinding resolveVariable()
Resolves and returns the field binding for this enum constant.

Note that bindings are generally unavailable unless requested when the AST is being built.

Returns:
  the binding, or `null` if the binding cannot be resolved